import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class zoomza extends PApplet {

HashSet squiggles = new HashSet();

Squiggle currentSquiggle;

public void setup(){
  size(500,500);

//  smooth();
}
float r = 1.1f;
float rs = -.0001f;
public void draw(){
    background(0); 
  Iterator i = squiggles.iterator();
  while(i.hasNext()){
    Squiggle s = (Squiggle)i.next();
    if(s != null){
    s.update();
    s.draw(); 
    }
  }
  if(currentSquiggle != null){
    currentSquiggle.add();
    currentSquiggle.update();
    currentSquiggle.draw();
      
}
  
  r += rs;
  if(r < .98f) { r = .98f; rs = abs(rs);}
  if(r > 1.02f) { r = 1.02f; rs = -abs(rs);}
  
}

public void keyPressed(){
   if(key == ' '){
       squiggles = new HashSet();

//Squiggle currentSquiggle;

   } 
}


public void mousePressed(){
   currentSquiggle = new Squiggle(); 
}
public void mouseReleased(){
  if(currentSquiggle == null){return;}
  squiggles.add(currentSquiggle); 
   currentSquiggle = null;
}

class Squiggle{

  ArrayList dots = new ArrayList(); 
  Dot startDot;
  int c ;
//float r = random(.98,1.02);
 
  Squiggle(){
    startDot = new Dot(mouseX,mouseY);
    c = color(random(50,255),random(50,255),random(50,255));
  }
  public void add(){
     dots.add(new Dot(mouseX,mouseY)); 
  }

  public void update(){
    updateDot(startDot);
    Iterator i = dots.iterator();
    while(i.hasNext()){
      updateDot((Dot)i.next());
     
    }
  }

   public void  updateDot(Dot d){
       float CENTERX = mouseX; float CENTERY = mouseY;// = 250;
      float dx = d.x - CENTERX; 
      float dy = d.y - CENTERY; 
      dx *= r;// 1.01;
      dy *= r; //1.01;
      d.x = CENTERX + dx;
      d.y = CENTERY + dy;
   }


  public void draw(){
    strokeWeight(3);

    stroke(c);

    Dot lastDot = startDot;
    Iterator i = dots.iterator();
    while(i.hasNext()){
      Dot d = (Dot)i.next();
      line(lastDot.x,lastDot.y,d.x,d.y);
      lastDot = d; 
    }




  }

  public void addSeg(){
    dots.add(new Dot(mouseX,mouseY));
  }

}

class Dot{
  Dot(float a,float b){
    x = a;
    y = b; 
  }
  float x, y; 
}



  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0F0", "zoomza" });
  }
}
